/* bounceAC.c */
/* Bouncing ball demo.
 * This program is in the public domain Brian Paul */ 
/* Conversion to GLUT by Mark J. Kilgard / Modifications by A. Christidis */

#include <conio.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <GL/glut.h>
//#pragma comment(linker,"/entry:mainCRTStartup")
//#pragma comment(lib, "OPENGL32.LIB")

#define COS(X)       cos( (X) * 3.14159/180.0 ) // X in Grad
#define SIN(X)       sin( (X) * 3.14159/180.0 ) // X in Grad
#define SPACE        1.5
#define ESC          27

/*Konsole-Mae:*/
#define CON_CLS     "cls"
#define CON_LINMIN    0
#define CON_LINMAX   24
#define CON_COLMIN    0
#define CON_COLMAX   2*CON_LINMAX 
//#define CON_COLMAX   79 /* Nicht: 80, da sonst Cursor-Position bei 81! */

/*Ball-Mae:*/
#define BAL_WID      11 // 11 darstellbare Zeichen
#define BAL_HIG       7
/*Ball-Bewegungsgrenzen:*/
#define BAL_LINMIN  (CON_LINMIN+BAL_HIG/2)   //  3
#define BAL_LINMAX  (CON_LINMAX-BAL_HIG/2)   // 21
#define BAL_COLMIN  (CON_COLMIN+BAL_WID/2)   //  5
#define BAL_COLMAX  (CON_COLMAX-BAL_WID/2-1) // 73

char     Buffer[CON_LINMAX][CON_COLMAX+1]; /* [CON_COLMAX + '\0'] */
GLuint   Ball;
GLenum   Mode;
GLfloat  Xpos = 0.0,  Ypos = 1.0;
GLdouble Xvel = 0.2,  Yvel = 0.0;
GLfloat  Xmin = -4.0, Xmax = 4.0;
GLdouble Ymin = -3.8, Ymax = 4.0;
GLdouble Grav = -0.1;
GLfloat  red=1., white=1.;
char     cons=0, dot=0;

/*************************************************************************/
  void conClrBuff (void)
/*************************************************************************/
{ int  j1=0,j2=0;

  for (j1=CON_LINMIN; j1<CON_LINMAX; j1++)
  { for (j2=CON_COLMIN; j2<CON_COLMAX; j2++) 
    { Buffer[j1][j2] = '\040';  //Wirkungsgleich: ' ' und '\040'!
    }
  } 
  return;
}

/*************************************************************************/
  void conClrScr (void)
/*************************************************************************/
{ system (CON_CLS);
  return;
}

/*************************************************************************/
  void conSwapBuff (void)
/*************************************************************************/
{ int  j1=0;

  conClrScr();

//Buffer[CON_LINMIN][CON_COLMIN] = 'A';
//Buffer[CON_LINMAX-1][CON_COLMAX-1] = 'Z';

  for (j1=CON_LINMIN; j1<CON_LINMAX; j1++)
  { printf (Buffer[j1]);  printf ("\n\r"); 
  }
  return;
}

/*************************************************************************/
  void conDrawBall (float Xpos, float Ypos)
/*************************************************************************/
{        int  j1=0, j2=0, Xcon=0, Ycon=0;
  static char BallChar[][BAL_WID+1]={ /* 11 Zeichen + \0 */
              {"\040\040\334\333\260\260\333\333\334\040\040"}, 
              {"\040\262\040\040\333\333\040\040\262\262\040"}, 
              {"\260\040\333\333\040\040\333\333\040\040\333"},
              {"\262\333\040\040\333\333\040\040\333\333\260"},
              {"\260\040\333\333\040\040\333\333\040\040\333"},
              {"\040\262\040\040\333\333\040\040\262\262\040"}, 
              {"\040\040\337\333\260\260\333\333\337\040\040"},
  /* "dot": */
              {"\040\040\040\040\040\040\040\040\040\040\040"}, 
              {"\040\040\040\040\040\040\040\040\040\040\040"}, 
              {"\040\040\040\040\040\040\040\040\040\040\040"}, 
              {"\040\040\040\040\040\333\040\040\040\040\040"},
              {"\040\040\040\040\040\040\040\040\040\040\040"}, 
              {"\040\040\040\040\040\040\040\040\040\040\040"}, 
              {"\040\040\040\040\040\040\040\040\040\040\040"}}; 

  /* Position der Ball-Bild-Mitte auf Konsole: */
  Xcon = (Xpos - Xmin) * (BAL_COLMAX-BAL_COLMIN) / (Xmax-Xmin) + BAL_COLMIN;
  Ycon = (Ypos - Ymin) * (BAL_LINMIN-BAL_LINMAX) / (Ymax-Ymin) + BAL_LINMAX;

  conClrBuff(); 

  Ycon =   Ycon -BAL_HIG/2;
  Xcon =   Xcon -BAL_WID/2;
  for (j1=0; j1<BAL_HIG; j1++)
  { for (j2=0; j2<BAL_WID; j2++)
    { Buffer[Ycon+j1][Xcon+j2] = (BallChar[dot+j1][j2]); 
    }
  }

  conSwapBuff ();
  return;
}

/*************************************************************************/
   void conInit()
/*************************************************************************/
{ system ("mode 49, 25"); // CON_COLMAX+1, CON_LINMAX+1
//  printf ("\n\rCON_COLMAX=%d, CON_LINMAX=%d\n\r", CON_COLMAX, CON_LINMAX);
//  _getch();
  conClrBuff(); 
  conClrScr(); 
  return;
}

/*************************************************************************/
  static GLuint make_ball(void)
/*************************************************************************/
{ GLuint  list;
  GLfloat a, b;
  GLfloat da = 18.0, db = 18.0;
  GLfloat radius = 2.;
  GLuint  color;
  GLfloat x, y, z;

  list = glGenLists(1);
  glNewList(list, GL_COMPILE);
  color = 0;
  for (a = -90.0; a + da <= 90.0; a += da) {
    glBegin(GL_QUAD_STRIP);
    for (b = 0.0; b <= 360.0; b += db) {
      if (color) { glColor3f (red, 0.f, 0.f); } 
      else       { glColor3f (white, white, white); }
      x =  radius * COS(b) * COS(a);
      z = -radius * SIN(b) * COS(a);  //Original: y = radius * ...
      y =  radius * SIN(a);           //Original: z = ...
      glVertex3f(x, y, z);

      x =  radius * COS(b) * COS(a + da);
      z = -radius * SIN(b) * COS(a + da); //Original: y = radius * ...
      y =  radius * SIN(a + da);          //Original: z = ...
      glVertex3f(x, y, z);

      color = 1 - color;
    }
    glEnd();
  }
  glEndList();
  return list;
}

/* ARGSUSED1 */
/*************************************************************************/
  static void key(unsigned char k, int x, int y)
/*************************************************************************/
{ x; y; //Vermeidung von Warnings
  switch (k)
  { case 'b': dot   = 7-dot;     /* dot vs. ball */
              break;
    case 'c': cons  = 1-cons;    /* console bounce */
              break;
    case 'r': red   = 1.-red;    /* red vs. black */
              white = 1.7-white;
              Ball  = make_ball();
              break;
    case ESC: exit(0);           /* Escape */
    }
}

/*************************************************************************/
  static void draw(void)
/*************************************************************************/
{ glClear(GL_COLOR_BUFFER_BIT);
  glPushMatrix();
  glTranslatef(Xpos, Ypos, 0.0);
  glCallList(Ball);
  glPopMatrix();
  glFlush();
  glutSwapBuffers();

  if (cons) conDrawBall (Xpos, Ypos);
  else      conClrScr(); 
}

/*************************************************************************/
  static void anim(void)
/*************************************************************************/
{ /*Berechnung in kart. Koord.*/
  static float vel0=1.1f;
  Xpos += Xvel;
  Ypos += Yvel;
  Yvel += Grav;

  if (Xpos >= Xmax) { Xpos = Xmax;  Xvel = -Xvel; } else
  if (Xpos <= Xmin) { Xpos = Xmin;  Xvel = -Xvel; }

  if (Ypos < Ymin)  { Ypos = Ymin;  Yvel = vel0;  }
  glutPostRedisplay();
}

/*************************************************************************/
  int main(int argc, char *argv[])
/*************************************************************************/
{ glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DOUBLE);
  conInit();

  printf ("\n\n\rconsole Bounce \n\r[toggle (r)ed, (c)onsole, (b)all] \
           \n\n\r(press any key)"); _getch();
  glutCreateWindow("conBounce [toggle (r)ed,(c)onsole,(b)all]");

  Ball = make_ball();
  glShadeModel(GL_FLAT);

  glOrtho(SPACE*Xmin, SPACE*Xmax, SPACE*Ymin, SPACE*Ymax, -6.0, 6.0);

  glutDisplayFunc(draw);
  glutIdleFunc(anim); //Eleganter: Knuepfg. an Sichtbarkeit (s.Original)
  glutKeyboardFunc(key);
  glutMainLoop();

  return 0;
}
