/*Beispiel fuer Codierung von Koordinaten und Eckpunkten in der CG:*/
#include <conio.h>  // wg. _getch()
#include <stdio.h>  // wg. printf()
#define NDIM  4

/*2 Moeglichkeiten: Punkt-Speicherung: als float[8][4] oder als Point[8]:*/
typedef float Point[NDIM];   // Raum-Koordinaten

int main()
{ int    j1=0, jF=0, jP=0;
  int    fcPtIdx  [6][4];    // Flaechen-Eckpunkt-Indizes
  float  cubVrtx_f[8][NDIM]; //Objektpunkt-Koordinaten eines Wuerfels
  Point  cubVrtx_C[8];
  float *facePnt_f[6][4];    //Flaechen-Ecken als Punkt-Adressen 
  Point *facePnt_C[6][4];

  /*facePnt_* speichern nur 24 Adressen (je 4 Byte) fuer 24 Punkte (je NDIM float):*/
  printf (" sizeof(facePnt_f)=%d; \t",   sizeof(facePnt_f));
  printf (" sizeof(facePnt_C)=%d\n\n\r", sizeof(facePnt_C));

  /*Koordinaten-Zuweisung (z.B.) fuer letzten Wuerfel-Punkt: 4;3;2;1*/
  cubVrtx_C[7][0] = 4; cubVrtx_C[7][1] = 3; cubVrtx_C[7][2] = 2; cubVrtx_C[7][3] = 1; 
  cubVrtx_f[7][0] = 4; cubVrtx_f[7][1] = 3; cubVrtx_f[7][2] = 2; cubVrtx_f[7][3] = 1; 

  /*Ab hier fuehrt die float-Version zu einfacheren Ausdruecken als die Point-Version:*/
  /*An letzter Flaeche [5] sei letzte Ecke [3] = letzter Wuerfel-Punkt [7]:*/
  fcPtIdx  [5][3] = 7; //Im folgenden 'fcPtIdx[5][3]' und '7' austauschbar
  facePnt_f[5][3] =   cubVrtx_f[7];
  facePnt_C[5][3] = &(cubVrtx_C[7]);
  //Komplex, aber auch korrekt:
  facePnt_f[5][3] = &cubVrtx_C[7][0];

  /*Feldname = Adresse des 1. Feldelementes:*/
  if ( cubVrtx_f[7] == &cubVrtx_f[7][0])
    printf ("\r cubVrtx_f[7] == &cubVrtx_f[7][0]  \n\n\r"); 
_getch();

  /*Bsp.: Ausgabe eines Koordinaten-Wertes; komplizierte Klammersetzung bei facePnt_C:*/
  j1=2;
  printf (" facePnt_C[5][3][%d]=%5.2f\n\r", j1, (*facePnt_C[5][3]) [j1]);
  printf (" facePnt_f[5][3][%d]=%5.2f\n\r", j1,   facePnt_f[5][3][j1]);
  printf (" cubVrtx_C[%d][%d]   =%5.2f\n\n\r", fcPtIdx[5][3], j1, cubVrtx_C[fcPtIdx[5][3]][j1]);

  /*Koordinaten-Ausgabe (hier: nur Flaeche [5], Punkt [3]):*/
  for (jF=5; jF<6; jF++)
  { for (jP=3; jP<4; jP++)
    { for (j1=0; j1<4; j1++)
      { printf (" facePnt_C[%d][%d][%d]=%5.2f"  //Ausgabe ueber Index
                " =cubVrtx_C[%d][%d]=%5.2f", //Eintrag-Adresse in Koordinatenliste
                jF, jP, j1, (*facePnt_C[jF][jP])[j1], 
                fcPtIdx[jF][jP], j1, cubVrtx_C[fcPtIdx[jF][jP]][j1]);
        printf (" =%5.2f \n\r",  //Ausgabe ueber Adresse
            *( **( *(facePnt_C+jF) +jP) +j1) );

        printf (" facePnt_f[%d][%d][%d]=%5.2f"  //Ausgabe ueber Index
                " =cubVrtx_f[%d][%d]=%5.2f", //Eintrag-Adresse in Koordinatenliste
                jF, jP, j1, facePnt_f[jF][jP][j1], 
                fcPtIdx[jF][jP], j1, cubVrtx_f[fcPtIdx[jF][jP]][j1]);
        printf (" =%5.2f \n\n\r",  //Ausgabe ueber Adresse
            *( *( *(facePnt_f+jF) +jP) +j1) );
      }
    }
  }  _getch();

  /*Eine(!) printf-Anweisung mit 3 A-priori-Inkrementierungen: Da der Inhalt hinter
    derselben Adresse vor der tatsaechlichen Ausgabe 3x inkrementiert wird, 
    erscheinen alle Werte um 3 erhoeht!*/
  for (j1=0; j1<4; j1++)
    printf (" facePnt_f[5][3][%d]=%5.2f"  //Ausgabe ueber Index
            " = *(facePnt_f[5][3]+%d)=%5.2f"  //Ausgabe ueber Adresse
            " = cubVrtx_C[7][%d]=%5.2f\n\r", //Eintrag-Adresse in Koordinatenliste
            j1, ++facePnt_f[5][3][j1], 
            j1, ++*(facePnt_f[5][3]+j1), 
            j1, ++cubVrtx_C[7][j1]);
  printf ("Ende!\n"); 
  _getch();
  return 0;
}
