/*                             GLUTbmpFont.c                              */
//#define  MIT_DOUBLE_BUFFER
#include <string.h>
#include <GL/glut.h>

void bmpOut(GLfloat x, GLfloat y, void *font, char *string)
{ int len, i;
  glRasterPos2f(x, y);
  len = (int) strlen(string);
  for (i = 0; i < len; i++) glutBitmapCharacter(font, string[i]);
}

void display(void)
{
  glClear(GL_COLOR_BUFFER_BIT);
  bmpOut(-1.f, 0.8f, GLUT_BITMAP_TIMES_ROMAN_24, 
         "Das ist GLUT_BITMAP_TIMES_ROMAN_24.");
  bmpOut(-0.5f, 0.3f, GLUT_BITMAP_9_BY_15, 
         "Und das nennt sich \"GLUT_BITMAP_9_BY_15\".");
  bmpOut(-0.75f, -0.75f, GLUT_BITMAP_HELVETICA_18, 
	     "Es gibt u.a. auch GLUT_BITMAP_HELVETICA_18.");
  glColor3f(1., 0., 0.);

  bmpOut(0.0f, 0.0f, GLUT_BITMAP_9_BY_15, 
         "<-- Fenster-Mitte bei (0,0)!");
  glColor3f(0., 0., 0.);
#ifdef   MIT_DOUBLE_BUFFER
glutSwapBuffers();  
#endif   MIT_DOUBLE_BUFFER
glFlush();
}

int main(int argc, char **argv)
{
  glutInit(&argc, argv);
  glutInitWindowSize(600, 300);
#ifdef   MIT_DOUBLE_BUFFER
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
  glutCreateWindow("GLUT bitmap fonts (Double buffered)");
#else    MIT_DOUBLE_BUFFER
  glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
  glutCreateWindow("GLUT bitmap fonts (Single buffered)");
#endif   MIT_DOUBLE_BUFFER
  glClearColor(1.0, 1.0, 1.0, 1.0);
  glColor3f(0., 0., 0.);
  glutDisplayFunc(display);
  glutMainLoop();
  return 0;
}

